//-----------------------------------------------------------------------------
// ዾ
//-----------------------------------------------------------------------------
// MinGW(gcc 4.4.1)ɂăRpC܂B
// filter.h ͌TCg AviUtl Plugin SDK ɓĂ܂B
//-----------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include "filter.h"

#define WINDOW_W 288
#define WINDOW_H 288

#define MAG_MAX  16      // őg嗦

static HDC bufDC = NULL;
static HBITMAP bufBMP = NULL;
static int bmp_width  = 0;
static int bmp_height = 0;
static POINT pos = {16,16};    // W
static POINT sub_pos = {0,0};  // TuW
static POINT drag_pos = {0,0}; // ÕhbOʒu

static int nnn = 2; // {
static int FixFlag = 0;
static int DragFlag = 0;
static int DragFlag2 = 0; // ҏWʗp

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
FILTER_DLL filter = {
    FILTER_FLAG_ALWAYS_ACTIVE|FILTER_FLAG_MAIN_MESSAGE|FILTER_FLAG_WINDOW_SIZE|FILTER_FLAG_DISP_FILTER|FILTER_FLAG_EX_INFORMATION|FILTER_FLAG_WINDOW_THICKFRAME,
    WINDOW_W,WINDOW_H,
    "ዾ",
    0,NULL,NULL,
    NULL,NULL,
    0,NULL,NULL,
    func_proc,
    NULL,
    NULL,
    NULL,
    func_WndProc,
    NULL,NULL,
    NULL,
    0,
    "ዾ r5",
    NULL,NULL,
    NULL,NULL,NULL,NULL,
    NULL,
};


//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    return &filter;
}

//---------------------------------------------------------------------
// YUY2tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTableYUY2( void )
{
    return &filter;
}

//---------------------------------------------------------------------
// foCXReLXgǗ
//---------------------------------------------------------------------
void mem_alloc( FILTER *fp )
{
    if( bufDC == NULL && bufBMP == NULL )
    {
        SYS_INFO si;
        fp->exfunc->get_sys_info( NULL, &si );
        HDC hdc = GetDC( fp->hwnd );
        bufDC = CreateCompatibleDC( hdc );
        bufBMP = CreateCompatibleBitmap( hdc, si.max_w, si.max_h ); // VRAMɋ󂫂΂Ɋmۂ
        SelectObject( bufDC, bufBMP );
        DeleteDC( hdc );
    }
}

void mem_free( void )
{
    if( bufDC )
    {
        DeleteDC( bufDC );
        bufDC = NULL;
    }
    if( bufBMP )
    {
        DeleteObject( (HGDIOBJ)bufBMP );
        bufBMP = NULL;
    }
}

//---------------------------------------------------------------------
// \
//---------------------------------------------------------------------
void disp( FILTER *fp, void *editp, POINT *pp )
{
    HDC hdc;
    RECT rc, blank_rc;
    BOOL is_editing = FALSE;

    if( fp ) is_editing = fp->exfunc->is_editing( editp );

    if( bufDC && is_editing )
    {
        hdc = GetDC( fp->hwnd );
        GetClientRect( fp->hwnd, &rc );

        if( pp )
        {
            pos.x = pp->x;
            pos.y = pp->y;
            sub_pos.x = sub_pos.y = 0;
        }

        // TuWCWɔf
        pos.x -= sub_pos.x / nnn;
        sub_pos.x %= nnn;
        pos.y -= sub_pos.y / nnn;
        sub_pos.y %= nnn;

        int center_x = (rc.right - rc.left) / 2;
        int center_y = (rc.bottom - rc.top) / 2;
        int dst_x = rc.left - pos.x * nnn + center_x + sub_pos.x;
        int dst_y = rc.top  - pos.y * nnn + center_y + sub_pos.y;
        int src_width  = bmp_width;
        int src_height = bmp_height;
        int dst_width  = src_width  * nnn;
        int dst_height = src_height * nnn;
        int src_x = 0;
        int src_y = 0;

        // ɗ]ȂhԂ
        if( dst_x > rc.left )
        {
            blank_rc.left   = rc.left;
            blank_rc.right  = dst_x;
            blank_rc.top    = rc.top;
            blank_rc.bottom = rc.bottom;
            FillRect(hdc, &blank_rc, (HBRUSH)(COLOR_ACTIVEBORDER+1));
        }
        // ɗ]ȂhԂ
        if( dst_y > rc.top )
        {
            blank_rc.left   = rc.left;
            blank_rc.right  = rc.right;
            blank_rc.top    = rc.top;
            blank_rc.bottom = dst_y;
            FillRect(hdc, &blank_rc, (HBRUSH)(COLOR_ACTIVEBORDER+1));
        }
        // Eɗ]ȂhԂ
        if( dst_x + dst_width < rc.right )
        {
            blank_rc.left   = dst_x + dst_width;
            blank_rc.right  = rc.right;
            blank_rc.top    = rc.top;
            blank_rc.bottom = rc.bottom;
            FillRect(hdc, &blank_rc, (HBRUSH)(COLOR_ACTIVEBORDER+1));
        }
        // ɗ]ȂhԂ
        if( dst_y + dst_height < rc.bottom )
        {
            blank_rc.left   = rc.left;
            blank_rc.right  = rc.right;
            blank_rc.top    = dst_y + dst_height;
            blank_rc.bottom = rc.bottom;
            FillRect(hdc, &blank_rc, (HBRUSH)(COLOR_ACTIVEBORDER+1));
        }

        // GcȃNbsO
        if( dst_x < rc.left )
        {
            int d     = rc.left - dst_x;
            int d_dst = d - d % nnn;
            int d_src = d / nnn;
            dst_x     += d_dst;
            dst_width -= d_dst;
            src_x     += d_src;
            src_width -= d_src;
        } 
        if( dst_x + dst_width > rc.right )
        {
            int d = (dst_x + dst_width) - rc.right;
            int d_dst = d - d % nnn;
            int d_src = d / nnn;
            dst_width -= d_dst;
            src_width -= d_src;
        }
        if( dst_y < rc.top )
        {
            int d = rc.top - dst_y;
            int d_dst = d - d % nnn;
            int d_src = d / nnn;
            dst_y      += d_dst;
            dst_height -= d_dst;
            src_y      += d_src;
            src_height -= d_src;
        }
        if( dst_y + dst_height > rc.bottom )
        {
            int d = (dst_y + dst_height) - rc.bottom;
            int d_dst = d - d % nnn;
            int d_src = d / nnn;
            dst_height -= d_dst;
            src_height -= d_src;
        }

        // [StretchDIBitsŊg]
        // StretchDIBits͋𒼂Ɋg又Ă]Ă炵B
        // \g又邽߁A̕Ԃ|Ă܂B
        // őOiKőGcɃNbsO邱ƂőxAbvĂB
        if( src_width > 0 && src_height > 0 )
        {
            SetStretchBltMode( hdc, COLORONCOLOR );
            StretchBlt(
                hdc, dst_x, dst_y, dst_width, dst_height,
                bufDC, src_x, src_y, src_width, src_height,
                SRCCOPY );
        }

        ReleaseDC( fp->hwnd, hdc );
    }
    else
    {
        hdc = GetDC( fp->hwnd );
        GetClientRect( fp->hwnd, &rc );
        FillRect( hdc, &rc, (HBRUSH)(COLOR_ACTIVEBORDER + 1) );
        ReleaseDC( fp->hwnd, hdc );
    }

}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp, FILTER_PROC_INFO *fpip )
{
    void *editp = fpip->editp;
    BOOL is_editing = fp->exfunc->is_editing( editp );

    if( bufDC && is_editing )
    {
        int w = fpip->w;
        int h = fpip->h;

        bmp_width  = w;
        bmp_height = h;

        // rbg}bṽwb_쐬
        BITMAPINFO bmi;
        ZeroMemory( &bmi, sizeof(bmi) );
        bmi.bmiHeader.biSize        = sizeof(bmi.bmiHeader);
        bmi.bmiHeader.biWidth       = w;
        bmi.bmiHeader.biHeight      = h;
        bmi.bmiHeader.biPlanes      = 1;
        bmi.bmiHeader.biBitCount    = 24;
        bmi.bmiHeader.biCompression = BI_RGB;
        bmi.bmiHeader.biPlanes      = 1;

        // rbg}bvbufDCɃRs[
        void *pixelp = fp->exfunc->get_disp_pixelp( editp, NULL );
        SetDIBitsToDevice(
            bufDC,
            0, 0, w, h,
            0, 0, 0, h,
            pixelp, &bmi, DIB_RGB_COLORS );

        disp( fp, editp, NULL ); // \
    }

    return TRUE;
}

//---------------------------------------------------------------------
// WndProc
//---------------------------------------------------------------------
BOOL func_WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam,void *editp, FILTER *fp )
{
    char title[1024] = "ዾ - 2{";
    static char fixed[128];
    int d;

    switch(message) {
        case WM_FILTER_INIT:
            //NɃEBhẼ^CgύX
            SetWindowText( hwnd, (LPCTSTR)title );
            break;

        case WM_PAINT:
        case WM_FILTER_CHANGE_EDIT:
        case WM_SIZE:
            disp( fp, editp, NULL );
            break;

        case WM_FILTER_FILE_OPEN:
            if( fp->exfunc->is_filter_window_disp( fp ) )
            {
                mem_alloc( fp );
            }
            break;

        case WM_FILTER_CHANGE_WINDOW:
             //tB^ L/ Ń
            if( fp->exfunc->is_filter_window_disp( fp ) )
            {
                mem_alloc( fp );
                return TRUE;
            }
            else
            {
                mem_free();
            }
            break;

        case WM_FILTER_FILE_CLOSE:
            mem_free();
            disp( fp, editp, NULL );
            break;

        case WM_FILTER_MAIN_MOUSE_DOWN:
            // ҏWʂŃ}EX{^
            if( !FixFlag )
            {
                // WύX
                POINT p;
                p.x = (int)((short)LOWORD(lparam));
                p.y = (int)((short)HIWORD(lparam));
                sub_pos.x = 0;
                sub_pos.y = 0;
                if( bufDC ) disp( fp, editp, &p );
                // hbOtO
                DragFlag2 = 1;
                DragFlag = 0; // Ô
            }
            else
            {
                DragFlag = DragFlag2 = 0; // Ô
            }
            break;

        case WM_FILTER_MAIN_MOUSE_UP:
        case WM_FILTER_MAIN_MOVESIZE:
        case WM_FILTER_MAIN_MOUSE_DBLCLK:
            // ҏWʂł̃hbOI
            DragFlag2 = 0;
            DragFlag = 0; // Ô
            break;

        case WM_FILTER_MAIN_MOUSE_MOVE:
            // ҏWʂŃ}EXړ
            if( !FixFlag && DragFlag2 && !DragFlag )
            {
                // hbOAWύX
                POINT p;
                p.x = (int)((short)LOWORD(lparam));
                p.y = (int)((short)HIWORD(lparam));
                sub_pos.x = 0;
                sub_pos.y = 0;
                if( bufDC ) disp( fp, editp, &p );
            }
            else
            {
                DragFlag = DragFlag2 = 0; // Ô
            }
            break;

        case WM_LBUTTONDOWN:
            if( !FixFlag )
            {
                // hbOJn
                DragFlag = 1;
                DragFlag2 = 0; // Ô
                drag_pos.x = (int)((short)LOWORD(lparam));
                drag_pos.y = (int)((short)HIWORD(lparam));
            }
            break;

        case WM_LBUTTONUP:
        case WM_NCMOUSEMOVE:
            // EChEł̃hbOI
            DragFlag = 0;
            DragFlag2 = 0; // Ô
            break;

        case WM_ACTIVATE:
            // ANeBuɂÔ߃hbOtONA
            if( LOWORD(wparam) == 0 )
            {
                DragFlag = 0;
            }
            break;

        case WM_MOUSEMOVE:
            if( !FixFlag && DragFlag )
            {
                // hbO
                POINT p;
                p.x = (int)((short)LOWORD(lparam));
                p.y = (int)((short)HIWORD(lparam));
                sub_pos.x += p.x - drag_pos.x;
                sub_pos.y += p.y - drag_pos.y;
                drag_pos.x = p.x;
                drag_pos.y = p.y;
                if (bufDC) disp(fp, editp, NULL);
            }
            else
            {
                DragFlag = DragFlag2 = 0; // Ô
            }
            break;

        case WM_MBUTTONUP:
            FixFlag = (FixFlag) ? 0 : 1;
            if( FixFlag )
            {
                sprintf(fixed, "[WŒ]");
                DragFlag = DragFlag2 = 0;
            }
            else
            {
                sprintf(fixed, " ");
            }
            sprintf( title, "ዾ - %d{ %s", nnn, fixed );
            SetWindowText( hwnd, (LPCTSTR)title );
            break;

        case WM_MOUSEWHEEL:
            d = (short)HIWORD(wparam);
            if( d < 0 ) // }EXzC[
            {
                if (nnn > 1)
                {
                    // k
                    nnn--;
                    sprintf( title, "ዾ - %d{ %s", nnn, fixed );
                    SetWindowText( hwnd, (LPCTSTR)title );
                    if( bufDC ) disp( fp, editp, NULL );
                }
                DragFlag = DragFlag2 = 0; // Ô
            }
            else if( d > 0 ) // }EXzC[
            {
                if( nnn < MAG_MAX )
                {
                    // g
                    nnn++;
                    sprintf( title, "ዾ - %d{ %s", nnn, fixed );
                    SetWindowText( hwnd, (LPCTSTR)title );
                    if( bufDC ) disp( fp, editp, NULL );
                }
                DragFlag = DragFlag2 = 0; // Ô
            }
            break;

        case WM_RBUTTONUP:
            if( nnn > 1 )
            {
                // k
                nnn--;
                sprintf( title, "ዾ - %d{ %s", nnn, fixed );
                SetWindowText( hwnd, (LPCTSTR)title );
                if( bufDC ) disp( fp, editp, NULL );
            }
            DragFlag = DragFlag2 = 0; // Ô
            break;

        case WM_LBUTTONDBLCLK:
            if( nnn < MAG_MAX )
            {
                // g
                nnn++;
                sprintf( title, "ዾ - %d{ %s", nnn, fixed );
                SetWindowText( hwnd, (LPCTSTR)title );
                if( bufDC ) disp( fp, editp, NULL );
            }
            DragFlag = DragFlag2 = 0; // Ô
            break;

        case WM_FILTER_EXIT:
            mem_free();
            break;

    }
    return FALSE;
}

